<!DOCTYPE html>
<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<html>
<head>
<%@taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<meta charset="utf-8">
<title>Bench4Q</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="description"
	content="Bench4Q, a new method for QOS benchmarking.">
<link id="bs-css" href="lib/chrisma/css/bootstrap-cerulean.css"
	rel="stylesheet">
<link href="lib/chrisma/css/opa-icons.css" rel="stylesheet">
<link
	href="http://ajax.aspnetcdn.com/ajax/bootstrap/2.3.2/css/bootstrap-responsive.css"
	rel="stylesheet">

<link href="lib/chrisma/css/charisma-app.css" rel="stylesheet">
<link href="lib/jquery/css/jquery-ui-1.10.4.css" rel="stylesheet">
<link href='css/scriptEditor.css' rel='stylesheet'>
<link rel="shortcut icon" href="images/bench4q.png">
<link rel="stylesheet" href="css/style.min.css" />

</head>
<body>
	<fmt:bundle basename="i18n">
		<jsp:include page="publiccontrol/navigatebar.jsp"></jsp:include>
		<div class="container-fluid">
			<div class="row-fluid">
				<jsp:include page="publiccontrol/leftmenubar.jsp"></jsp:include>

				<div id="content" class="span10">
					<ul class="breadcrumb">
						<li><a href="homepage.jsp"><fmt:message key="home" /></a> <span
							class="divider">/</span></li>
						<li><a href="script.jsp"><fmt:message
									key="scriptmanagement" /></a><span class="divider">/</span></li>
						<li><a href="createScript.jsp"><fmt:message
									key="home-createScript" /></a></li>
					</ul>
					<div id="tabs">
						<ul>
							<li><a href="#usePluginPanel"><fmt:message
										key="plugin_jsp_plugins" />(usePlugins)</a></li>
							<li><a href="#behavior"><fmt:message
										key="plugin_jsp_behavior" />(behaviors)</a></li>
							<li><a href="#submitScriptPanel"><fmt:message
										key="script-submitScript" /></a></li>
						</ul>
						
						<div id="usePluginPanel">
							<div class="span5 editorContainer">
								<div class="header">
									<h4>
										<span><fmt:message key="plugin_jsp_plugins" />(usePlugins)</span>
									</h4>
								</div>
								<div class="row-fluid ">
									<div class="span9 " id="usePluginList"></div>
									<div class="span3 buttonsControl ">
										<div>
											<button type="submit" class="btn btn-primary btn-width"
												id="addPlugin">
												<fmt:message key="plugin_jsp_add" />
											</button>
										</div>
										<div>
											<button type="submit" class="btn btn-primary btn-width"
												id="removePlugin">
												<fmt:message key="plugin_jsp_remove" />
											</button>
										</div>
										<div>
											<button type="submit" class="btn btn-primary btn-width"
												id="clearPlugin">
												<fmt:message key="plugin_jsp_clear" />
											</button>
										</div>
									</div>

								</div>
							</div>
							<div class="span7 editorContainer">

								<div class="header">
									<h4>
										<span><fmt:message key="plugin_jsp_plugins" />(usePlugins)</span>
									</h4>
								</div>
								<div id="pluginEditor"></div>
							</div>
						</div>
						<div id="behavior">
							<div class="span5 editorContainer">
								<div class="header">
									<h4>
										<span><fmt:message key="plugin_jsp_behavior" />
											(behaviors)</span>
									</h4>
								</div>
								<div class="row-fluid">
									<div class="span9" id="useBehaviorList"></div>
									<div class="span3 buttonsControl">
										<div id="insertChildDiv" class="hide">
											<button type="submit" class="btn btn-primary btn-width"
												id="insertChildNode">
												<fmt:message key="plugin_jsp_insertChild" />
											</button>
										</div>
										<div>
										<button type="submit" class="btn btn-primary btn-width"
											id="addBehavior">
											<fmt:message key="plugin_jsp_add" />
										</button>
										</div>
										<div>
											<button type="submit" class="btn btn-primary btn-width"
												id="removeBehavior">
												<fmt:message key="plugin_jsp_remove" />
											</button>
										</div>
										<div>
											<button type="submit" class="btn btn-primary btn-width"
												id="clearBehavior">
												<fmt:message key="plugin_jsp_clear" />
											</button>
										</div>

									</div>
								</div>
							</div>
							<div class="span7 editorContainer">
								<div class="header">
									<h4>
										<span><fmt:message key="plugin_jsp_behavior" />
											(behaviors)</span>
									</h4>

								</div>
								<div id="behaviorEditor"></div>
							</div>
						</div>
						<div id="submitScriptPanel">
							<div class="span12">
								<label><fmt:message key="scriptname" /></label> <input
									type='text' name='scriptName' id="scriptName"></input>
								<button id="submitScript" type="submit" class="btn btn-primary">
									<fmt:message key="script-submitScript" />
								</button>
							</div>


						</div>
					</div>
				</div>
			</div>
			<hr>

			<div class="modal hide fade " id="selectUsePlugin">
				<div class="modal-header">
					<button type="button" id="myModal-close" class="close"
						data-dismiss="modal">×</button>
					<h3>
						<fmt:message key="plugin_jsp_addNewPlugin" />
					</h3>
				</div>
				<div class="modal-body"">
					<div class="inset scroll" id="pluginList"></div>
				</div>
				<div class="modal-footer">

					<button type="button" class="btn btn-primary btn-width" id="ok">
						<fmt:message key="plugin_jsp_finish" />
					</button>
					<button type="button" class="btn btn-primary btn-width" id="cancel">
						<fmt:message key="plugin_jsp_cancel" />
					</button>
				</div>
			</div>

			<div class="modal hide fade " id="selectBehavior">
				<div class="modal-header">
					<button type="button" id="myModal-close" class="close"
						data-dismiss="modal">×</button>
					<h3>
						<fmt:message key="plugin_jsp_chooseBehaviors" />
					</h3>
				</div>
				<div class="modal-body">
					<div class="row-fluid">
						<div class="span6 behavior-box scroll">
							<div id="usePlugins"></div>
						</div>
						<div class="span6 behavior-box scroll">
							<div id="pluginMethod"></div>
						</div>

					</div>
				</div>
				<div class="modal-footer">

					<button type="button" class="btn btn-primary btn-width" id="ok">
						<fmt:message key="plugin_jsp_finish" />
					</button>
					<button type="button" class="btn btn-primary btn-width" onClick=""
						id="cancel">
						<fmt:message key="plugin_jsp_cancel" />
					</button>

				</div>
			</div>
		</div>
		<hr>
		<jsp:include page="publiccontrol/footer.jsp"></jsp:include>
		<script
			src="http://ajax.aspnetcdn.com/ajax/jQuery/jquery-2.1.0.min.js"></script>
		<script src="lib/jquery/js/jquery-ui-1.10.4.js"></script>
		<script src="lib/jqueryi18n/jquery.i18n.properties-1.0.9.js"></script>
		<script src="lib/bootstrap/js/bootstrap-modal.js"></script>
		<script src="lib/chrisma/js/jquery.cookie.js"></script>
		<script src="lib/chrisma/js/theme.js"></script>
		<script src="lib/other/jstree.min.js"></script>
		<script src="http://cdn.alloyui.com/2.5.0/aui/aui-min.js"></script>
		<script src="lib/other/jquery.noty.packaged.min.js"></script>
		<script src="lib/other/jquery.msgbox.min.js"></script>
		<script src="lib/HashMap/HashMap.js"></script>
		<script src="script/Share/getUrlVars.js"></script>
		<script src="script/scriptManager/editorFactory.js"></script>
		<script src="script/scriptManager/dataFormat.js"></script>
		<script src="script/scriptManager/containerFactory.js"></script>
		<script src="script/scriptManager/dataCollect.js"></script>
		<script src="script/scriptManager/uiFactory.js"></script>
		<script src="script/scriptManager/behavior.js"></script>
		<script src="script/scriptManager/usePlugin.js"></script>
		<script src="script/scriptManager/submitScript.js"></script>
		<script src="script/scriptManager/jstreeFactory.js"></script>		
		<script src="script/scriptManager/scriptEditor.js"></script>
		<script src="script/scriptManager/scriptModels.js"></script>
		<script src="script/scriptManager/contentVerification.js"></script>
	</fmt:bundle>
</body>
</html>
