function createCheckbox(id,text){
	var line = $("<td style=\"cursor:pointer;\"></td>");
	line.click(function(){checkBoxClick(id)});
	var input = $("<input type='checkbox' name='filterList' id="+id+">");
	input.attr("text",text);
	input.click(function(){checkBoxClick(id)});
	line.append(input);
	line.append(document.createTextNode(text));
	line.addClass("line");
	return line;
}
function checkBoxClick(id){
	if(document.getElementById(id).checked){
		document.getElementById(id).checked = false;
	}else{
		document.getElementById(id).checked = true;
	}
}

function loadSchedulePlot() {
	var options = {
		chart : {
			renderTo : 'highchartsPlot',
			defaultSeriesType : 'line',
			type : 'area',
			height : 300,

		},
		plotOptions : {
			series : {
				fillOpacity : 0.5,
			}
		},
		credits : {
			enabled : false
		},
		legend : {
			enabled : false
		},
		title : {
			text : $.i18n.prop('test-loadSchedule') ,
			x : -50
		},
		xAxis : {
			categories : [ 0 ],
			min : 0,
		},
		yAxis : {
			plotLines : [ {
				value : 0,
				width : 1,
				color : '#808080'
			} ],
			min : 0
		},
		tooltip : {
			formatter : function() {
				var formatStr = '<b>'+this.y+ ' users after ' + this.x + ' seconds</b>';
				return formatStr;
			}
		},
		series : [ {
			data : [ 0 ]
		} ]
	}; 
	var RequireLoad = parseInt($("#RequireLoad").val());
	var WarmUp = parseInt($("#WarmUp").val());
	var CoolDown = parseInt($("#CoolDown").val());
	var ExecuteRange = parseInt($("#ExecuteRange").val());
	options.xAxis.categories.push(WarmUp);
	options.xAxis.categories.push(WarmUp + ExecuteRange);
	options.xAxis.categories.push(WarmUp + ExecuteRange + CoolDown);
	options.series[0].data.push(RequireLoad);
	options.series[0].data.push(RequireLoad);
	options.series[0].data.push(0);
	var chart = new Highcharts.Chart(options);
}


function toggleTestExecutionPlan() {
	$("#loadTestExecutionPlan").slideToggle();
	$('#loadConfigMessage').attr("class", "hide");
	if ($("#icon-load").attr("class") == "icon-plus")
		$("#icon-load").attr("class", "icon-minus");
	else
		$("#icon-load").attr("class", "icon-plus");
}
function toggleUserScenarios() {
	$("#userScenarios").slideToggle();
	$('#alertMessage').attr("class", "hide");
	$('#userConfigMessage').attr("class", "hide");
	if ($("#icon-user").attr("class") == "icon-plus")
		$("#icon-user").attr("class", "icon-minus");
	else
		$("#icon-user").attr("class", "icon-plus");
}
function toggleIpConfig() {
	$("#ipConfig").slideToggle();
	$('#ipConfigMessage').attr("class", "hide");
	if ($("#icon-ip").attr("class").indexOf("icon-plus") >= 0)
		$("#icon-ip").attr("class", "icon-minus");
	else
		$("#icon-ip").attr("class", "icon-plus");
}